#ifndef NEW_YORK_TRANSIT_LINE_CORE_H
#define NEW_YORK_TRANSIT_LINE_CORE_H

#include "templater.h"
#include <functional>

/* Do not export this header */

namespace nytl {
    void debug_print_templater(const Templater& T);

    /* ============== For parsing =============================*/
    void parse_bare_file(const std::string& filename, const std::string& content,
            global_elem_set_t& result);

    void parse_special_file(const std::string& filename, const std::string& content,
        global_elem_set_t& result, TemplaterSettings& syntax);

    /* =================== For rendering ====================*/
    struct LocalVarValue {
        bool is_json = false;
        std::string EL_name;
        const json::JSON* JSON_subval = NULL;
    };

    /* No new JSON object will ever be created, I have one root json argument,
     * all the other json variables are subtrees of it */
    LocalVarValue rendering_core_execute_expression(const global_elem_set_t& global_elems,
        const std::vector<LocalVarValue>& local_vars, const json::JSON& expr);

    std::string rendering_core(const std::string& entry_func, const std::vector<const json::JSON*>& entry_arguments,
        const global_elem_set_t& elem_ns, const std::function<std::string(std::string)>& escape);
}

#endif
